
#include <avr/io.h>
#include <avr/wdt.h>

#ifndef UBRRL
#define UBRRL UBRR1L
#endif
#ifndef UBRRH
#define	UBRRH UBRR1H
#endif
#ifndef UCSRA
#define	UCSRA UCSR1A
#endif
#ifndef UCSRB
#define UCSRB UCSR1B
#endif
#ifndef UCSRC
#define	UCSRC UCSR1C
#endif
#ifndef UDR
#define UDR UDR1
#endif

#ifndef UDRE
#define UDRE UDRE1
#endif

int main()
{
	char b;
	UBRRL = 5; // 5 - 115200 bps
	UBRRH = 0;
	UCSRA = 0x00;
	UCSRC = 0x06;
	UCSRB = _BV(RXEN) | _BV(TXEN);

	OCR0  = 54;  // 2.5 ms 
	TIMSK  = 0; // disable timer interrupt
	TIFR = TIFR; // clear all signal

	
	while(1)
	{
		while(bit_is_clear(UCSRA,RXC))
			wdt_reset();
					
		b=UDR;
		
	
		if(b=='1')
		{
//			((void (*) ())0x0f800)();
			asm("jmp 0x1F800");
		}
		else
		{
			loop_until_bit_is_set(UCSRA,UDRE);
			UDR=b;		
		}
	
	}
	return 0;
}

